/******************************************************************************
 *	seese.c:	t@C͗p^_CAO֐W[
 ******************************************************************************
 *	Workroom SX-68K Sample Program Copyright 1994 SHARP
 */
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <sxmemory.h>		/* }𗘗pƂɕKv	*/
#include <event.h>		/* Cxg}𗘗pƂɕKv	*/
#include <sxgraph.h>		/* Ot}𗘗pƂɕKv	*/
#include <control.h>		/* Rg[}𗘗pƂɕKv	*/
#include <dialog.h>		/* _CAO}𗘗pƂɕKv	*/
#include <text.h>		/* eLXg}𗘗pƂɕKv	*/
#include <task.h>		/* ^XN}𗘗pƂɕKv	*/
#include "sedit.h"		/* ̃vOŗL̃wb_t@C	*/

/******************************************************************************
 *	openEseDlg():	^_CAÕI[v
 ******************************************************************************
 *	:	EseDlg *pese	^_CAOR[hւ̃|C^
 *		Window *winPtr	EBhE|C^
 *		char *title	_CAO^Cgւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  쐬
 *				= FALSE: 쐬s
 *	:
 *	^_CAÕ[NB
 *	^_CAO̕\showEseDlg()ōsB
 */
BOOLEAN openEseDlg(EseDlg *pese, Window *winPtr, char *title)
{
	/* ^_CAO̊eW */
	static Rect rcFrame = {		/* Og				*/
		ESE_X + 0, ESE_Y + 0, ESE_X + 321, ESE_Y + 104
	};
	static Rect rcText = {		/* eLXg͗		*/
		ESE_X + 13, ESE_Y + 30, ESE_X + 305, ESE_Y + 58
	};
	static Rect rcPart = {		/* {^̃p[eBV	*/
		ESE_X + 218, ESE_Y + 67, ESE_X + 301, ESE_Y + 97
	};
	/* _CAO^Cg̕\ʒu */
	static Point ttlPos = { ESE_X + 15, ESE_Y + 15 };

	pese->windowPtr = winPtr;
	pese->rcFrame = rcFrame;	/* OgN^O̓o^	*/
	pese->rcText = rcText;		/* eLXgGfBbgp̃N^O */
	pese->rcDest = rcText;

	pese->rcPart = rcPart;		/* {^͂ރN^O	*/
	pese->ttlPos = ttlPos;		/* ^Cg\W		*/
	pese->visible = 0;

	pese->title = MMChHdlNew(256);	/* ^Cgpnhmۂ */
	if (pese->title == NULL)
		return FALSE;

	strcpy(*pese->title, title);	/* ^Cgݒ肷		*/
	if (!createEseText(pese))	/* eLXgGfBbg쐬	*/
		return FALSE;

	if (!createEseControl(pese))	/* Rg[쐬	*/
		return FALSE;

	return TRUE;
}

/******************************************************************************
 *	closeEseDlg():	^_CAÕN[Y
 ******************************************************************************
 *	:	EseDlg *pese	^_CAOR[hւ̃|C^
 *	:
 *	^_CAOAmۂĂRg[nhȂǁAׂĔp
 *	܂B
 */
void closeEseDlg(EseDlg *pese)
{
	int lastFC, lastAP;

	if (pese->visible) {
		GMSetGraph(&pese->windowPtr->graph);

		/* ANZXy[WOƂPy[Wɂ */
		lastAP = GMAPage(G_PAGE0 | G_PAGE1);
		lastFC = GMForeColor(G_LGRAY);
		releaseClip(pese->windowPtr);
		GMFillRect(&pese->rcFrame);
		addUpdate(pese->windowPtr, &pese->rcFrame);
		GMAPage(lastAP);
		GMForeColor(lastFC);
	}
	if (pese->tEditHdl != NULL) {
		/* eLXgGfBbgnhp */
		TMDispose(pese->tEditHdl);
		pese->tEditHdl = NULL;
	}
	if (pese->execBtnHdl != NULL) {
		CMDispose(pese->execBtnHdl);
		pese->execBtnHdl = NULL;
	}
	if (pese->canBtnHdl != NULL) {
		CMDispose(pese->canBtnHdl);
		pese->canBtnHdl = NULL;
	}
	MMHdlDispose(pese->title);	/* nh		*/
	pese->title = NULL;
}

/******************************************************************************
 *	drawEseDlg():	^_CAO̕`
 ******************************************************************************
 *	:	EseDlg *pese	^_CAOR[hւ̃|C^
 */
void drawEseDlg(EseDlg *pese)
{
	int lastAP, lastFC, lastBC, lastFK;

	if (!pese->visible)		/* \ĂȂH		*/
		return;

	GMSetGraph(&pese->windowPtr->graph);

	releaseClip(pese->windowPtr);
	/* ANZXy[WOƂPy[Wɂ */
	lastAP = GMAPage(G_PAGE0 | G_PAGE1);
	lastFC = GMForeColor(G_BLACK);
	lastBC = GMBackColor(G_LGRAY);
	lastFK = GMFontKind(G_ROM12);

	GMScrewRect(&pese->rcFrame);	/* lWtN^O\	*/
	GMShadowRect(&pese->rcPart);
	CMDrawOne(pese->execBtnHdl);	/* {^`悷		*/
	CMDrawOne(pese->canBtnHdl);
	MMHdlLock(pese->title);
	GMShadowStrZ(*pese->title, pese->ttlPos.x_y); /* {^`悷 */
	MMHdlUnlock(pese->title);

	GMBackColor(G_WHITE);
	GMShadowRect(&pese->rcText);
	/* eLXgGfBbg̕`悷 */
	TMUpDate(pese->tEditHdl, &pese->rcText);

	GMAPage(lastAP);
	GMForeColor(lastFC);
	GMBackColor(lastBC);
	GMFontKind(lastFK);

	setClip(pese->windowPtr, &pese->rcFrame);
}

/******************************************************************************
 *	showEseDlg():	^_CAO̕\
 ******************************************************************************
 *	:	EseDlg *pese	^_CAOR[hւ̃|C^
 */
void showEseDlg(EseDlg *pese)
{
	int lastFC, lastAP;

	if (pese->visible)
		return;

	GMSetGraph(&pese->windowPtr->graph);

	releaseClip(pese->windowPtr);
	/* ANZXy[WOƂPy[Wɂ */
	lastAP = GMAPage(G_PAGE0 | G_PAGE1);
	lastFC = GMForeColor(G_LGRAY);

	GMPenHide();
	CMShow(pese->execBtnHdl);
	CMShow(pese->canBtnHdl);
	GMPenShow();
	TMShow(pese->tEditHdl);
	pese->visible = TRUE;

	GMAPage(lastAP);
	GMForeColor(lastFC);

	addUpdate(pese->windowPtr, &pese->rcFrame);
	setClip(pese->windowPtr, &pese->rcFrame);
}

/******************************************************************************
 *	hideEseDlg():	^_CAȌ
 ******************************************************************************
 *	:	EseDlg *pese	^_CAOR[hւ̃|C^
 */
void hideEseDlg(EseDlg *pese)
{
	int lastFC, lastAP;

	if (!pese->visible)		/* \ĂȂH		*/
		return;

	GMSetGraph(&pese->windowPtr->graph);

	/* ANZXy[WOƂPy[Wɂ */
	lastAP = GMAPage(G_PAGE0 | G_PAGE1);
	lastFC = GMForeColor(G_LGRAY);

	releaseClip(pese->windowPtr);
	pese->visible = FALSE;
	CMHide(pese->execBtnHdl);
	CMHide(pese->canBtnHdl);
	TMHide(pese->tEditHdl);
	GMFillRect(&pese->rcFrame);
	addUpdate(pese->windowPtr, &pese->rcFrame);

	GMAPage(lastAP);
	GMForeColor(lastFC);
}

/******************************************************************************
 *	createEseText():	^_CAOpeLXgGfBbg̍쐬
 ******************************************************************************
 *	:	EseDlg *pese	^_CAOR[hւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  쐬
 *				= FALSE: 쐬s
 */
BOOLEAN createEseText(EseDlg *pese)
{
	int errCode;

	/* eLXgGfBbgpfBXeBl[VN^O쐬 */
	pese->rcDest.d.left++;
	pese->rcDest.d.top++;
	pese->rcDest.d.right -= 2;
	pese->rcDest.d.bottom -= 2;

	errCode = TMNew2(&pese->rcDest, &pese->rcDest, &pese->windowPtr->graph, &pese->tEditHdl);
	if (errCode < 0)
		/* eLXgGfBbg쐬łȂ */
		return FALSE;

	(*pese->tEditHdl)->lenMax = TS_NAMEMAX; /* ͍ő啶ݒ肷 */
	(*pese->tEditHdl)->lineHeight = T_LHEIGHT; /* sݒ肷	*/
	(*pese->tEditHdl)->editMode = 0; /* ҏW[hʏ\ɂ	*/
	/* t@NVL[ATCe[uݒ肷 */
	(*pese->tEditHdl)->funcCode = funcKeyTbl;

	return TRUE;
}

/******************************************************************************
 *	createEseControl():	^_CAÕRg[̍쐬
 ******************************************************************************
 *	:	EseDlg *pese	^_CAOR[hւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  쐬
 *				= FALSE: 쐬s
 */
BOOLEAN createEseControl(EseDlg *pese)
{
	static Rect rcExecBtn  = {	/* [s]{^			*/
		ESE_X + 224, ESE_Y + 73, ESE_X + 224 + CHRBTN_H + 12 * 2, ESE_Y + 73 + CHRBTN_V
	};
	static Rect rcCanBtn = {	/* []{^			*/
		ESE_X + 266, ESE_Y + 73, ESE_X + 266 + CHRBTN_H + 12 * 2, ESE_Y + 73 + CHRBTN_V
	};

	pese->execBtnHdl = CMOpen(pese->windowPtr, &rcExecBtn,
		(_LASCII)"\x04s", FALSE, 0, 0, 1, CI_CHRBTN << 4, 0);
	if (pese->execBtnHdl == NULL)
		return FALSE;

	pese->canBtnHdl = CMOpen(pese->windowPtr, &rcCanBtn,
		(_LASCII)"\x04", FALSE, 0, 0, 1, CI_CHRBTN << 4, 0);
	if (pese->canBtnHdl == NULL)
		return FALSE;

	return TRUE;
}

/******************************************************************************
 *	caretEseDlg():	^_CAÕJ[\
 ******************************************************************************
 *	:	EseDlg *pese	^_CAOR[hւ̃|C^
 *		BOOLEAN sw	= TRUE:  \
 *				= FALSE: 
 */
void caretEseDlg(EseDlg *pese, BOOLEAN sw)
{
	int lastAP, lastFC, lastBC, lastFK;

	if (!pese->visible)		/* \ĂȂH		*/
		return;

	GMSetGraph(&pese->windowPtr->graph);

	releaseClip(pese->windowPtr);	/* NbsO	*/
	/* ANZXy[WOƂPy[Wɂ */
	lastAP = GMAPage(G_PAGE0 | G_PAGE1);
	lastFC = GMForeColor(G_BLACK);
	lastBC = GMBackColor(G_WHITE);
	lastFK = GMFontKind(G_ROM12);

	TMCaret(pese->tEditHdl, sw);	/* J[\I^It	*/

	GMAPage(lastAP);
	GMForeColor(lastFC);
	GMBackColor(lastBC);
	GMFontKind(lastFK);
	setClip(pese->windowPtr, &pese->rcFrame); /* NbsO߂	*/
}

/******************************************************************************
 *	eseDlgEvent():	Cxgɉ
 ******************************************************************************
 *	:	EseDlg *pese	^_CAOR[hւ̃|C^
 *		TsEvent *ptsev	^XN}CxgR[hւ̃|C^
 *	߂l:	int num		= 1: [s]{^
 *				= 2: []{^
 */
int eseDlgEvent(EseDlg *pese, TsEvent *ptsev)
{
	int lastAP, lastFC, lastBC, lastFK;
	int keyCode;			/* L[R[h			*/
	int shortCut;			/* V[gJbgL[		*/
	int num = 0;
	int partCode;			/* Rg[̃p[gR[h	*/
	LPoint lpt;
	Control **ctrlHdl;		/* Rg[nh		*/

	if (!pese->visible)		/* \ĂȂH		*/
		return 0;

	GMSetGraph(&pese->windowPtr->graph);

	releaseClip(pese->windowPtr);
	/* ANZXy[WOƂPy[Wɂ */
	lastAP = GMAPage(G_PAGE0 | G_PAGE1);
	lastFC = GMForeColor(G_BLACK);
	lastBC = GMBackColor(G_WHITE);
	lastFK = GMFontKind(G_ROM12);

	switch (ptsev->ts.what) {
	case E_IDLE:			/* AChCxg		*/
		TMEventW(pese->tEditHdl, ptsev); /* J[\_ł */
		break;
	case E_KEYDOWN:			/* L[_ECxg		*/
		/* t@NVATCe[uɂL[R[hϊ */
		keyCode = TMKeyToAsk(pese->tEditHdl, ptsev);
		if (keyCode == -2) {	/* e[uɓo^ĂȂH	*/
			/* OPT.1L[ꂽH */
			if (ptsev->ev.how & KS_OPT1) {
				/* L[͂啶ɕϊ */
				shortCut = toupper((int) ptsev->ev.whom.key.ascii);
				switch (shortCut) {
				case 'Q': /* I			*/
					num = 2; /* []{^	*/
					break;
				default:
					/* eLXg}̃V[gJbg
					   Ή */
					TMEventW(pese->tEditHdl, ptsev);
					break;
				}
			} else {
				switch (ptsev->ev.whom.key.ascii) {
				case '\r':	/* ^[L[ENTERL[ */
					num = 1; /* [s]{^	*/
					break;
				case '\x1b':	/* ESCL[		*/
					num = 2; /* []{^	*/
					break;
				default:	/* ̑̃L[		*/
					TMEventW(pese->tEditHdl, ptsev);
					break;
				}
			}
		} else
			/* ̑̃L[̏ꍇ */
			TMEventW(pese->tEditHdl, ptsev);
		break;
	case E_MSLDOWN:			/* }EXtg_ECxg	*/
		/* _CAOO̍ẂA`FbNȂ */
		lpt = GMGlobalToLocal(ptsev->ev.where.x_y);
		if (GMPtInRect(&pese->rcFrame, lpt)) {
			partCode = CMFind(lpt, pese->windowPtr, &ctrlHdl);
			if (ctrlHdl == pese->execBtnHdl) {
				if (CMCheck(ctrlHdl, lpt, NULL) == C_INBTTN)
					num = 1; /* [s]{^	*/
			} else if (ctrlHdl == pese->canBtnHdl) {
				if (CMCheck(ctrlHdl, lpt, NULL) == C_INBTTN)
					num = 2; /* []{^	*/
			} else
				TMEventW(pese->tEditHdl, ptsev);
		}
		break;
	case E_MSRDOWN:			/* }EXCg_ECxg	*/
		TMEventW(pese->tEditHdl, ptsev);
		break;
	}
	GMAPage(lastAP);
	GMForeColor(lastFC);
	GMBackColor(lastBC);
	GMFontKind(lastFK);
	setClip(pese->windowPtr, &pese->rcFrame);

	return num;
}

/******************************************************************************
 *	dropEseIcon():	ACR̃hbv
 ******************************************************************************
 *	:	EseDlg *pese	^_CAOR[hւ̃|C^
 *		TsEvent *ptsev	^XN}CxgR[hւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  hbv
 *				= FALSE: hbvf[^̎擾Ɏs
 */
BOOLEAN dropEseIcon(EseDlg *pese, TsEvent *ptsev)
{
	int errCode, len;
	int lastAP, lastFC, lastBC, lastFK;
	BOOLEAN ret = FALSE;		/* Ăяo֐^[li[p	*/
	Drag *dragPtr;			/* hbO|C^		*/
	Cell *pcell;			/* ZR[hւ̃|C^	*/
	char fileName[TS_NAMEMAX];	/* t@C			*/

	errCode = TSGetDrag(&dragPtr);	/* hbO|C^擾	*/
	if (errCode < 0)
		/* hbOR[h */
		return FALSE;

	MMHdlLock(dragPtr->cellList);	/* ZXgւ̃nhbN */
	pcell = *dragPtr->cellList;	/* ZR[hւ̃|C^擾 */
	TSHideDrag();			/* o[oh	*/
	/* ZR[h̏̎ނACRǗR[hiʃ[h'FS'j
	   H */
	if (HIWORD(pcell->kind) == 'FS') {
		/* ACR͂PihbOR[h̃ZXg̒ACR
		   ǗR[h܂ރZR[h̒Ɠ̏ꍇjH */
		if (dragPtr->size == sizeof(IcState) + 8 ) {
			/* ACR̃tpX擾 */
			len = TSISRecToStr((IcState *) pcell->data, fileName);
			if (len >= 0) {
				GMSetGraph(&pese->windowPtr->graph);

				releaseClip(pese->windowPtr);
				/* ANZXy[WOƂPy[Wɂ */
				lastAP = GMAPage(G_PAGE0 | G_PAGE1);
				lastFC = GMForeColor(G_BLACK);
				lastBC = GMBackColor(G_WHITE);
				lastFK = GMFontKind(G_ROM12);

				/* eLXgGfBbgɑ} */
				TMInsert(pese->tEditHdl, fileName, len);

				GMAPage(lastAP);
				GMForeColor(lastFC);
				GMBackColor(lastBC);
				GMFontKind(lastFK);
				TSEndDrag(TS_FINISH); /* hbOI */
				ret = TRUE;
				setClip(pese->windowPtr, &pese->rcFrame);
			} else {
				/* ACR̈ʒuɂ͂΂ďI */
				TSEndDrag(TS_PUTBACK);
				ret = FALSE;
			}
		} else {
			/* ACRQȏォ̃hbOR[h
			   ACR̈ʒuɂ͂΂ďI */
			TSEndDrag(TS_PUTBACK);
			ret = FALSE;
		}
	}

	/* ZXgւ̃nh̃bN */
	MMHdlUnlock(dragPtr->cellList);
	return ret;
}

/******************************************************************************
 *	getEseStr():	̎擾
 ******************************************************************************
 *	:	EseDlg *pese	^_CAOR[hւ̃|C^
 *		char *ptext	i[obt@ւ̃|C^
 *	߂l:	int len		<  0: G[R[h
 *				>= 0: ̒
 */
int getEseStr(EseDlg *pese, char *ptext)
{
	int len;

	len = TMGetText(pese->tEditHdl, ptext, TS_NAMEMAX);
	ptext[len] = 0;

	return len;
}

/******************************************************************************
 *	setEseStr():	̐ݒ
 ******************************************************************************
 *	:	EseDlg *pese	^_CAOR[hւ̃|C^
 *		char *ptext	i[obt@ւ̃|C^
 *		int length	̒
 *	߂l:	int errCode	< 0: G[R[h
 */
int setEseStr(EseDlg *pese, char *ptext, int length)
{
	int errCode;

	errCode = TMSetText(pese->tEditHdl, ptext, length);
	if (pese->visible)
		/* \Ă΃Abvf[g */
		addUpdate(pese->windowPtr, &pese->rcDest);

	return errCode;
}

/******************************************************************************
 *	setClip():	NbsO̐ݒ
 ******************************************************************************
 *	:	Window *winPtr	EBhE|C^
 *		Rect *prc	N^Oւ̃|C^
 */
void setClip(Window *winPtr, Rect *prc)
{
	Region **rgnHdl;

	rgnHdl = GMNewRgn();
	if (rgnHdl == NULL) {
		TSErrDialogN(D_CONFIRM, "mۂł܂B");
		return;
	}
	GMRectRgn(rgnHdl, &winPtr->graph.rect);
	GMDiffRectRgn(rgnHdl, rgnHdl, prc);
	GMSetClip(rgnHdl);
	GMDisposeRgn(rgnHdl);		/* [Wnh	*/
}

/******************************************************************************
 *	releaseClip():	NbsỎ
 ******************************************************************************
 *	:	Window *winPtr	EBhE|C^
 */
void releaseClip(Window *winPtr)
{
	GMClipRect(&winPtr->graph.rect);
}
